-- /*******************************************************************************

--   Copyright (c) 2010, 2013 LIFIA - Facultad de Informatica - Univ. Nacional de La Plata
--   All rights reserved.

-- ********************************************************************************

--   Redistribution and use in source and binary forms, with or without 
--   modification, are permitted provided that the following conditions are met:
--     * Redistributions of source code must retain the above copyright
--       notice, this list of conditions and the following disclaimer.
--     * Redistributions in binary form must reproduce the above copyright
--       notice, this list of conditions and the following disclaimer in the
--       documentation and/or other materials provided with the distribution.
--     * Neither the name of the author nor the names of its contributors may
--       be used to endorse or promote products derived from this software
--       without specific prior written permission.

--   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
--   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
--   DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
--   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
--   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
--   OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
--   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
--   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
--   EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

-- ********************************************************************************

--   La redistribución y el uso en las formas de código fuente y binario, con o sin
--   modificaciones, están permitidos siempre que se cumplan las siguientes condiciones:
--     * Las redistribuciones del código fuente deben conservar el aviso de copyright
--       anterior, esta lista de condiciones y el siguiente descargo de responsabilidad.
--     * Las redistribuciones en formato binario deben reproducir el aviso de copyright
--       anterior, esta lista de condiciones y el siguiente descargo de responsabilidad
--       en la documentación y/u otros materiales suministrados con la distribución.
--     * Ni el nombre de los titulares de derechos de autor ni los nombres de sus
--       colaboradores pueden usarse para apoyar o promocionar productos derivados de
--       este software sin permiso previo y por escrito.

--   ESTE SOFTWARE SE SUMINISTRA POR LIFIA "COMO ESTÁ" Y CUALQUIER GARANTÍA EXPRESA
--   O IMPLÍCITA, INCLUYENDO, PERO NO LIMITADO A, LAS GARANTÍAS IMPLÍCITAS DE
--   COMERCIALIZACIÓN Y APTITUD PARA UN PROPÓSITO DETERMINADO SON RECHAZADAS. EN
--   NINGÚN CASO LIFIA SERÁ RESPONSABLE POR NINGÚN DAÑO DIRECTO, INDIRECTO, INCIDENTAL,
--   ESPECIAL, EJEMPLAR O CONSECUENTE (INCLUYENDO, PERO NO LIMITADO A, LA ADQUISICIÓN
--   DE BIENES O SERVICIOS; LA PÉRDIDA DE USO, DE DATOS O DE BENEFICIOS; O INTERRUPCIÓN
--   DE LA ACTIVIDAD EMPRESARIAL) O POR CUALQUIER TEORÍA DE RESPONSABILIDAD, YA SEA
--   POR CONTRATO, RESPONSABILIDAD ESTRICTA O AGRAVIO (INCLUYENDO NEGLIGENCIA O
--   CUALQUIER OTRA CAUSA) QUE SURJA DE CUALQUIER MANERA DEL USO DE ESTE SOFTWARE,
--   INCLUSO SI SE HA ADVERTIDO DE LA POSIBILIDAD DE TALES DAÑOS.

-- *******************************************************************************/

----------------------------------------------------------------------------------
-- Root Window
-----------------------------------------------------------------------------------

RootWindow = wndNew( 'Root', nil, 0, 0 )

function RootWindow.actions.onCreate( win )
	--	Resize
	wndResize( RootWindow, canvas.size() )

	--	Setup keys
	win.keys.Press = {
		  [KEY_CHANNEL_UP]   = 'onChannelUp'
		, [KEY_SMALL_Q]      = 'onChannelUp'
		, [KEY_CURSOR_RIGHT] = 'onChannelUp'
		, [KEY_CHANNEL_DOWN] = 'onChannelDown'
		, [KEY_SMALL_Z]      = 'onChannelDown'
		, [KEY_CURSOR_LEFT]  = 'onChannelDown'

		, [KEY_MUTE]         = 'onMute'
		, [KEY_SMALL_M]      = 'onMute'
		, [KEY_VOLUME_UP]    = 'onVolUp'
		, [KEY_SMALL_W]      = 'onVolUp'
		, [KEY_VOLUME_DOWN]  = 'onVolDown'
		, [KEY_SMALL_X]      = 'onVolDown'

		, [KEY_MENU]         = 'onToggleMenu'
		, [KEY_SMALL_C]      = 'onToggleMenu'

		, [KEY_SMALL_R]      = 'onScan'
	
		, [KEY_EXIT]         = 'onExit'
	
		, [KEY_SUBTITLE]     = 'onToggleSub'
		, [KEY_SMALL_S]      = 'onToggleSub'
		, [KEY_AUDIO]        = 'onNextAudio'
		, [KEY_SMALL_A]      = 'onNextAudio'

		, [KEY_SMALL_F]      = 'onToggleFullScreen'
	}

	win.keys.Release = {
		  [KEY_SMALL_L]      = 'onToggleChannelList'
	}
end

function RootWindow.actions.onButton()
	wdtToggleVisible( MenuWindow )
end

function RootWindow.actions.onChannelUp()
	changeFactor(1)
end

function RootWindow.actions.onChannelDown()
	changeFactor(-1)
end

function RootWindow.actions.onMute()
	toggleMute()
end

function RootWindow.actions.onVolUp()
	volumenUp()
end

function RootWindow.actions.onVolDown()
	volumenDown()
end

function RootWindow.actions.onToggleSub()
	nextSubtitle()
end

function RootWindow.actions.onNextAudio()
	nextAudio()
end

function RootWindow.actions.onToggleMenu()
	wdtToggleVisible( MenuWindow )
end

function RootWindow.actions.onToggleFullScreen()
	toogleFullScreen()
end

function RootWindow.actions.onToggleChannelList()
	toggleChannelList()
end

function RootWindow.actions.onScan( win )
	logMethod( TRACE, 'OnScan' )
	startScan( win, function () ChannelList.variables.needsListUpdate = true end )
end

function RootWindow.actions.onExit()
	log( TRACE, 'On exit!' )
	exitLoop()
end

